明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1515|回复: 6

[VBA]关于选择集

[复制链接]
发表于 2005-12-7 17:36:00 | 显示全部楼层 |阅读模式

我想用一闭合多段线为边界选择其内部的图形,采用selectbypolygen方法,但发现与边界相连的多边形或线段都选不上,如下图,有其它方法吗?

d:\未命名.bmp

发表于 2005-12-7 22:27:00 | 显示全部楼层

object.SelectByPolygon Mode, PointsList, FilterType, FilterData

Mode用acSelectionSetCrossingPolygon

 楼主| 发表于 2005-12-8 14:48:00 | 显示全部楼层

莫名你好,如果Mode采用acSelectionSetCrossingPolygon 的话与边界相连的外面的多边形也会被选中。我主要是用来计算图斑面积时扣除内部图斑的面积,不知有没有好一点的办法。

d:\未命名.bmp

 楼主| 发表于 2005-12-22 13:37:00 | 显示全部楼层
沉到底了,自己顶一下,大家给个答案啊
 楼主| 发表于 2006-1-4 14:41:00 | 显示全部楼层
自己顶
 楼主| 发表于 2006-1-5 14:57:00 | 显示全部楼层

程序如下:
Sub selectPl()
    Dim ent As AcadEntity
    Dim SelObj As AcadEntity
    Dim NumSel As Integer
    Dim Coord As Variant
    Dim CoordCount As Integer
    Dim NewCoord() As Double
    Dim i As Integer
   
    Dim ssetObj As AcadSelectionSet
    On Error GoTo Err1:
    Set ssetObj = ThisDrawing.SelectionSets.Add("TEST_SSET2")
   
    On Error Resume Next
    Do
        ThisDrawing.Utility.GetEntity ent, pnt, "选择多段线:"
        If Err Then Exit Sub
        If TypeName(ent) Like "IAcad*Polyline" Then Exit Do
    Loop
   
If TypeName(ent) = "IAcadLWPolyline" Then
        Coord = ent.Coordinates
        CoordCount = (UBound(Coord) + 1) / 2 '顶点数
        '定义新的顶点坐标数组
        ReDim NewCoord(0 To (3 * CoordCount - 1)) As Double
        For i = 0 To UBound(Coord) - 1 Step 2
            NewCoord((3 * i) / 2) = Coord(i)
            NewCoord((3 * i) / 2 + 1) = Coord(i + 1)
            NewCoord((3 * i) / 2 + 2) = 0
        Next i
ElseIf TypeName(ent) = "IAcadPolyline" Then
        Coord = ent.Coordinates
        CoordCount = (UBound(Coord) + 1) / 3
        ReDim NewCoord(0 To UBound(Coord)) As Double
        For i = 0 To UBound(Coord) - 1
            NewCoord(i) = Coord(i)
            NewCoord(i) = Coord(i)
            NewCoord(i) = Coord(i)
        Next

End If
ssetObj.SelectByPolygon acSelectionSetWindowPolygon, NewCoord
ssetObj.Highlight True
ssetObj.Update
NumSel = ssetObj.Count
Exit Sub
Err1:
    ThisDrawing.SelectionSets.Item("TEST_SSET2").Delete
    Resume
End Sub

本帖子中包含更多资源

您需要 登录 才可以下载或查看,没有账号?注册

x
 楼主| 发表于 2006-1-10 20:00:00 | 显示全部楼层
还是自己顶,有人回答一下是如果根本没办法解决有话就不顶了
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-27 06:25 , Processed in 0.176022 second(s), 24 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表